//Achernar
#include <stdio.h>
#include <math.h>

typedef struct {
  int x;
  int y;
  double iri;
  double ori;
  double f;
  int   done;
} KOLESO;

KOLESO kol[21];
int n;
int konfotac;

double tav[21][21];

int bicikli(int kol);

int main() {
  int x,y, ir,or, w;
  int sukolie=0, i, k;
  int retval;
  scanf("%d %d   %d %d   %d %d", &x,&y,  &ir,&or,  &w,&n);
  while (!(x==0 && y==0 && ir==0 && or==0 && w==0 && n==0)) {
    sukolie++;

    konfotac = 0;
    // A nulladik kerek lesz a hajto kerek:
    kol[0].x = x;
    kol[0].y = y;
    kol[0].iri = (double) ir;
    kol[0].ori = (double) or;
    kol[0].f = (double) w;
    kol[0].done = 1;

    // Tobbi kerek adatanak beolvasasa:
    for (k=1; k<=n; k++) {
	int x,y, i,o;
	scanf("%d %d %d %d", &x,&y, &i,&o);
	kol[k].x = x;
	kol[k].y = y;
	kol[k].iri = (double) i;
	kol[k].ori = (double) o;
	kol[k].f = 0.0;
	kol[k].done = 0;
    }

    // A folosleges helyet toroljuk a tombben:
    for (k=n+1; k<=20; k++) {
	kol[k].x = 0;
	kol[k].y = 0;
	kol[k].iri = 0.0;
	kol[k].ori = 0.0;
	kol[k].f = 0.0;
	kol[k].done = 0;
    }

    int xdiff, ydiff;
    for (i=0; i<n; i++) {
      for (k=i+1; k<=n; k++) {
	xdiff = abs(kol[i].x - kol[k].x);
	ydiff = abs(kol[i].y - kol[k].y);
	if (xdiff==0)
	   tav[i][k] = (double) ydiff;
	else if (ydiff==0)
	   tav[i][k] = (double) xdiff;
	else
	   tav[i][k] = sqrt((double) xdiff*xdiff + (double) ydiff*ydiff);
	tav[k][i] = tav[i][k];
      }
    }

    printf("Sukolie %d\n", sukolie);
    retval = bicikli(0);
    if (retval==0) { // Normalis visszateres - minden rendben.
       if (konfotac!=0)
	    printf("Porucha -- konflikt otacania kolies\n");
       else {
	for (i=1; i<=n; i++) {
	 printf("%2d: ", i);

	 if (kol[i].f==0.0) // Nem forog a kerek.
	    printf("koleso sa neotaca\n");
	 else {
	    if (kol[i].f<0) // Oramutatoval ellentetesen forog.
	       printf("P %.2f\n", -kol[i].f);
	    else            // Oramutatoval egy iranyban forog.
	       printf("S %.2f\n", +kol[i].f);
	 }
	}
       }
    } else if (retval==1) { // Atfedesi hibakod.
       printf("Porucha -- prekrytie kolies\n");
    } else if (retval==2) { // Rossz forgas hibakodja.
       printf("Porucha -- konflikt otacania kolies\n");
    } //if

    // Minden 'sukolie' utan kihagyunk egy helyet:
    printf("\n");

    scanf("%d %d   %d %d   %d %d", &x,&y,  &ir,&or,  &w,&n);
  } //while
  return 0;
}

int bicikli(int koleso) {
//  printf("bicikli(%d):\n", koleso);
  for (int i=0; i<n+1; i++) {
    if (i==koleso) continue;

//    printf("   %d - %d", koleso, i);

//    int xdiff = abs(kol[koleso].x - kol[i].x);
//    int ydiff = abs(kol[koleso].y - kol[i].y);
    int iri1 = (int) kol[koleso].iri, iri2 = (int) kol[i].iri;
    int ori1 = (int) kol[koleso].ori, ori2 = (int) kol[i].ori;

/*    if ((xdiff==0 || ydiff==0) &&
	((xdiff>0 && (xdiff<iri1+iri2 || xdiff<ori1+ori2)) ||
	(ydiff>0 && (ydiff<iri1+ori2 || ydiff<ori1+ori2))))
	    return 1; // prekrytie kolies

    if (xdiff>0 && ydiff>0)
       continue;*/

//    int diff = (xdiff>0) ? xdiff : ydiff;
    double diff = tav[koleso][i];
    if (diff< (double) (iri1+iri2) || diff< (double) (ori1+ori2))
	 return 1;

    if (diff == ((double) iri1 + iri2)) {
	 // kol[i].f == -kol[koleso].f * kol[koleso].ori/kol[i].iri
	 double expectedf = -kol[koleso].f * ((double) iri1)/((double) iri2);
	 if (kol[i].done==1) {
	    if (kol[i].f != expectedf)
		konfotac=1;
//		return 2; // konflikt otacania
	 } else { // kol[i].done==0
	    kol[i].done = 1;
	    kol[i].f = expectedf;

	    int retval=bicikli(i); // De ha a 'retval' 0, akkor folytatodik.
	    if (retval==1)
	      return 1;
//	    else if (retval==2)
//	      konfotac=1;
//	      return 2;
	 }
    }

    if (diff == ((double) ori1 + ori2)) {
	 double expectedf = -kol[koleso].f * ((double) ori1)/((double) ori2);
	 if (kol[i].done==1) {
	    if (kol[i].f != expectedf)
		konfotac=1;
//		return 2; // konflikt otacania
	 } else { // kol[i].done==0
	    kol[i].done = 1;
	    kol[i].f = expectedf;

	    int retval=bicikli(i); // De ha a 'retval' 0, akkor folytatodik.
	    if (retval==1)
	      return 1;
//	    else if (retval==2)
//	      konfotac=1;
//	      return 2;
	 }
    }

/*    if (diff == ori1+ori2) {
	 float expectedf = -kol[koleso].f * ((float) ori1)/((float) ori2);
	 if (kol[i].done==1) {
	    if (kol[i].f != expectedf)
		return 2; // konflikt otacania
	 } else { // kol[i].done==0
	    kol[i].done = 1;
	    kol[i].f = expectedf;

	    int retval=bicikli(i); // De ha a 'retval' 0, akkor folytatodik.
	    if (retval==1)
	      return 1;
	    else if (retval==2)
	      return 2;
	 }
    }

    if (diff == iri1+iri2) {
	 float expectedf = -kol[koleso].f * ((float) iri1)/((float) iri2);
	 if (kol[i].done==1) {
	    if (kol[i].f != expectedf)
		return 2; // konflikt otacania
	 } else { // kol[i].done==0
	    kol[i].done = 1;
	    kol[i].f = expectedf;

	    int retval=bicikli(i); // De ha a 'retval' 0, akkor folytatodik.
	    if (retval==1)
	      return 1;
	    else if (retval==2)
	      return 2;
	 }
    }*/
  }

  return 0;
}
